unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    TreeTreeRes: TTreeView;
    Label1: TLabel;
    CBTypeAny: TCheckBox;
    CBTypeDisk: TCheckBox;
    CBTypePrint: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Label2: TLabel;
    Button1: TBitBtn;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure EnumNet(const ParentNode: TTreeNode;
                                 ResScope, ResType: DWORD;
                                 const NetContainerToOpen: PNetResource);
    function OpenEnum(const NetContainerToOpen: PNetResource;
                      ResScope, ResType, ResUsage: DWORD): THandle;
    function EnumResources(const ParentNode: TTreeNode;
                           ResScope, ResType, ResUsage: DWORD;
                           hNetEnum: THandle): UINT;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  ResScope,
  ResType:DWORD;
begin
 TreeTreeRes.Items.Clear;

 if RadioButton2.Checked then
  ResScope := RESOURCE_GLOBALNET
 else
  if RadioButton1.Checked then
   ResScope := RESOURCE_CONNECTED
  else
   ResScope := RESOURCE_REMEMBERED;

 ResType := 0;
 if CBTypeAny.Checked then
  ResType := ResType or RESOURCETYPE_ANY;
 if CBTypeDisk.Checked then
  ResType := ResType or RESOURCETYPE_DISK;
 if CBTypePrint.Checked then
  ResType := ResType or RESOURCETYPE_PRINT;

 EnumNet(TreeTreeRes.Items.Add(NIL, ' '),ResScope, ResType, NIL);
end;


procedure TForm1.EnumNet(const ParentNode: TTreeNode; ResScope, ResType: DWORD;
                         const NetContainerToOpen: PNetResource);
var
  hNetEnum: THandle;
begin
 hNetEnum := OpenEnum(NetContainerToOpen, ResScope, ResType, RESOURCEUSAGE_CONNECTABLE or RESOURCEUSAGE_CONTAINER);
 if (hNetEnum = 0) then exit;
 EnumResources(ParentNode, ResScope, ResType, RESOURCEUSAGE_CONNECTABLE or RESOURCEUSAGE_CONTAINER, hNetEnum);
 if (NO_ERROR <> WNetCloseEnum(hNetEnum)) then
  ShowMessage('WNetCloseEnum Error');
end;

function TForm1.OpenEnum(const NetContainerToOpen: PNetResource;
                         ResScope, ResType, ResUsage: DWORD): THandle;
var
 hNetEnum: THandle;
begin
 Result := 0;
 if (NO_ERROR <> WNetOpenEnum(ResScope, ResType, RESOURCEUSAGE_CONNECTABLE or RESOURCEUSAGE_CONTAINER,
                               NetContainerToOpen, hNetEnum)) then
  showmessage(' ')
 else
  Result := hNetEnum;
end;


function TForm1.EnumResources(const ParentNode: TTreeNode;
                              ResScope, ResType, ResUsage: DWORD;
                              hNetEnum: THandle): UINT;
 function ShowResource(const ParentNode: TTreeNode; Res: TNetResource): TTreeNode;
 var
  Str:String;
  index:Integer;
 begin
  Result:=ParentNode;
  if Res.lpRemoteName=nil then exit;
  Str:=string(Res.lpRemoteName);
  index:=Pos('\',Str);
  While index>0 do
   begin
    Str:=Copy(Str,index+1,Length(Str));
    index:=Pos('\',Str);
   end;
  Result := TreeTreeRes.Items.AddChild(ParentNode, Str);
 end;
var
 ResourceBuffer: array[1..2000] of TNetResource;
 i,ResourceBuf,EntriesToGet: DWORD;
 NewNode: TTreeNode;
begin
 Result := 0;
 while TRUE do
  begin
   ResourceBuf := sizeof(ResourceBuffer);
   EntriesToGet := 2000;

   if (NO_ERROR <> WNetEnumResource(hNetEnum,EntriesToGet,@ResourceBuffer,ResourceBuf)) then
    begin
     case GetLastError() of
       NO_ERROR: break;
       ERROR_NO_MORE_ITEMS: exit;
     else
      ShowMessage(' ');
      Result := 1;
      exit;
     end;
    end;

   for i := 1 to EntriesToGet do
    begin
     NewNode := ShowResource(ParentNode, ResourceBuffer[i]);
     if (ResourceBuffer[i].dwUsage and RESOURCEUSAGE_CONTAINER) <> 0 then
      EnumNet(NewNode, ResScope, ResType, @ResourceBuffer[i]);
    end;
  end;
end;

end.



